<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctEncerraContrato {
    
    const NOME = "FCT_ENCERRA_CONTRATO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param string $idorcacontr
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($nrseqcontrato, $operador, $nrorg, $dtrecisao, $idtpexclusaoparcela = 2) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQCONTRATO",    Param::PARAM_INPUT,  $nrseqcontrato,       Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_OPERADOR",         Param::PARAM_INPUT,  $operador,            Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRORG",            Param::PARAM_INPUT,  $nrorg,               Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_DTRECISAOCONTR",   Param::PARAM_INPUT,  $dtrecisao,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDTPEXCLUSAOPARC", Param::PARAM_INPUT,  $idtpexclusaoparcela, Param::PARAM_TYPE_INT));
        
        $procedure->execute();
    }
    
}

?>